//+------------------------------------------------------------------+
//|                                                         Zig1.mq4 |
//|                                                         |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//   .   .      :)))
//:
//  1)  .      ,    High    Low.
//      ,     (.. )    .
//   2)   .         
//       .   .      up  1  
//      0  .         
//	    .
//  3)     
//		3.1)  up=1.    .   High  ,  
//	        .   Low     ,   (3.3)
//		3.2)  up=0.    .   Low   ,  
//		        .   High     ,   (3.3)
// 	3.3)      .   up c 1  0   0  1. 
//	       (3)


extern int nBars=512;
extern int Step=100;
extern color Col=255;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double ZigBuffer[];
double s;

int init()
  {
//---- indicators
  IndicatorBuffers(1);
  SetIndexStyle(0,DRAW_SECTION);
  SetIndexBuffer(0,ZigBuffer);
  SetIndexEmptyValue(0,0.0);
  if(nBars > Bars) nBars=Bars;
  s=Step;
  s=s/10000;
  ZigZag();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

double Min, Max;
int MaxIdx, MinIdx;
double CurMax, CurMin;





void ZigZag()
{
   double Max, Min, Cur;
   int iMax, iMin, iCur, up;   
   int i, n;   
   
   //        Step
   Max=High[nBars]; Min=Low[nBars];
   for(i=nBars; i>0; i--) //    ,   
   {
      if(Low[i]<Min)  {Min=Low[i];  iMin=i;}
      if(High[i]>Max) {Max=High[i]; iMax=i;}      
      if((Max-Min) >= s) break;
   }
   //  
   if(iMin > iMax)
   {// (      mql4)
      up=1;
      ZigBuffer[iMin]=Min; 
      Cur=Max;
   }
   else
   {//
      up=0;
      ZigBuffer[iMax]=Max; 
      Cur=Min;
   }
   
   n=1;
   //    
   while(i>0)
   {
      if(up==1) 
      {// 
			while(i>0)
			{// ,  ,   Low  
				if(High[i]>Cur) {iCur=i; Cur=High[i];}
				if((Cur-Low[i]) >= s) break;
				i--;
			}               
      }
      else
      {// 
			while(i>0)
			{// ,  ,   High  
				if(Low[i]<Cur) {iCur=i; Cur=Low[i];}
				if((High[i]-Cur) >= s) break;
				i--;
			}      
      }
      //    
      ZigBuffer[iCur]=Cur;
      if(up==1) up=0; else up=1; // 
      i--;
      n++;
   }   
   Print("ZigCat find ", n, " points");
}

int start()
  {
   int    counted_bars=IndicatorCounted();
//----
//   ZigZag();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+